package cn.ibizlab.businesscentral.core.product.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.businesscentral.core.product.domain.ProductSubStitute;
import cn.ibizlab.businesscentral.core.product.filter.ProductSubStituteSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[ProductSubStitute] 服务对象接口
 */
public interface IProductSubStituteService extends IService<ProductSubStitute>{

    boolean create(ProductSubStitute et) ;
    void createBatch(List<ProductSubStitute> list) ;
    boolean checkKey(ProductSubStitute et) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean update(ProductSubStitute et) ;
    void updateBatch(List<ProductSubStitute> list) ;
    boolean save(ProductSubStitute et) ;
    void saveBatch(List<ProductSubStitute> list) ;
    ProductSubStitute get(String key) ;
    ProductSubStitute getDraft(ProductSubStitute et) ;
    Page<ProductSubStitute> searchDefault(ProductSubStituteSearchContext context) ;
    List<ProductSubStitute> selectByProductid(String productid) ;
    void removeByProductid(String productid) ;
    List<ProductSubStitute> selectBySubstitutedproductid(String productid) ;
    void removeBySubstitutedproductid(String productid) ;
    List<ProductSubStitute> selectByTransactioncurrencyid(String transactioncurrencyid) ;
    void removeByTransactioncurrencyid(String transactioncurrencyid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<ProductSubStitute> getProductsubstituteByIds(List<String> ids) ;
    List<ProductSubStitute> getProductsubstituteByEntities(List<ProductSubStitute> entities) ;

}


